> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/connections/create.md).

# Create Connection

Create a new connection to an AI provider.

## Endpoint

{% code title="Endpoint" %}

```
POST /umbraco/ai/management/api/v1/connections
```

{% endcode %}

## Request

### Headers

| Header       | Value              |
| ------------ | ------------------ |
| Content-Type | `application/json` |

### Body

{% code title="Request Body" %}

```json
{
    "alias": "openai-prod",
    "name": "OpenAI Production",
    "providerId": "openai",
    "isActive": true,
    "settings": {
        "apiKey": "sk-your-api-key",
        "organization": null
    }
}
```

{% endcode %}

### Required Fields

| Field        | Type   | Description                               |
| ------------ | ------ | ----------------------------------------- |
| `alias`      | string | Unique alias (lowercase, hyphens allowed) |
| `name`       | string | Display name                              |
| `providerId` | string | ID of the provider to use                 |

### Optional Fields

| Field      | Type    | Default | Description                   |
| ---------- | ------- | ------- | ----------------------------- |
| `isActive` | boolean | true    | Whether connection is enabled |
| `settings` | object  | null    | Provider-specific settings    |

### Settings with Configuration References

Use `$` prefix to reference values from configuration. References resolve from the `Umbraco:AI:Secrets` and `Umbraco:AI:Variables` sections by default:

{% code title="Request with Config Reference" %}

```json
{
    "alias": "openai-prod",
    "name": "OpenAI Production",
    "providerId": "openai",
    "settings": {
        "apiKey": "$Umbraco:AI:Secrets:OpenAIApiKey"
    }
}
```

{% endcode %}

## Response

### Success (201 Created)

{% code title="Response" %}

```json
{
    "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
    "alias": "openai-prod",
    "name": "OpenAI Production",
    "providerId": "openai",
    "isActive": true,
    "version": 1,
    "dateCreated": "2024-01-15T10:30:00Z",
    "dateModified": "2024-01-15T10:30:00Z",
    "createdByUserId": null,
    "modifiedByUserId": null,
    "settings": {
        "apiKey": "sk-***",
        "organization": null
    }
}
```

{% endcode %}

### 400 Bad Request

#### Missing Required Field

{% code title="Response" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.1",
    "title": "Bad Request",
    "status": 400,
    "detail": "Alias is required"
}
```

{% endcode %}

#### Duplicate Alias

{% code title="Response" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.1",
    "title": "Bad Request",
    "status": 400,
    "detail": "A connection with alias 'openai-prod' already exists"
}
```

{% endcode %}

#### Invalid Provider

{% code title="Response" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.1",
    "title": "Bad Request",
    "status": 400,
    "detail": "Provider 'invalid-provider' not found"
}
```

{% endcode %}

## Examples

### cURL

{% code title="cURL" %}

```bash
curl -X POST "https://your-site.com/umbraco/ai/management/api/v1/connections" \
  -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  -d '{
    "alias": "openai-prod",
    "name": "OpenAI Production",
    "providerId": "openai",
    "settings": {
      "apiKey": "sk-your-api-key"
    }
  }'
```

{% endcode %}

### JavaScript

{% code title="JavaScript" %}

```javascript
async function createConnection(connection) {
    const response = await fetch("/umbraco/ai/management/api/v1/connections", {
        method: "POST",
        headers: {
            "Content-Type": "application/json",
        },
        credentials: "include",
        body: JSON.stringify(connection),
    });

    if (!response.ok) {
        const error = await response.json();
        throw new Error(error.detail);
    }

    return await response.json();
}

// Usage
const connection = await createConnection({
    alias: "openai-prod",
    name: "OpenAI Production",
    providerId: "openai",
    settings: {
        apiKey: "$Umbraco:AI:Secrets:OpenAIApiKey",
    },
});
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/connections/create.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
